# include <stdio.h>
# include <malloc.h>
# include <string.h>
# include <stdlib.h>
# include <dirent.h>
# include <locale.h>
# include <sys/types.h>
# include <sys/stat.h>

# include <s_defkey.h>
# include <x_schone.h>
# include <mylib.h>
# include <menu.h>
# include <main.h>
# include <slowo.h>

# define min(a,b) (((a)<(b)) ? (a) : (b))
# define max(a,b) (((a)>(b)) ? (a) : (b))

// ------------------------------------------------------------------------
struct t_TextStande
{  char color ;     // 
   char Font[99] ;  //  
};
struct t_DictStande
{  t_TextStande Text[5] ;
   char  Divider[10] ; // 
   char  SortOrder ;   //  0 - - 1 - -
   char  fTrans ;      //   
};

struct t_Stande1
{
   char          Path[200] ;
   char          Geometry[20] ;
   t_DictStande *Dict ;
   short         i_default_Dict ;
   short         n_Dict ;
   void          init( void );
   char          read1( void );
   void          read2( void );
   void          write( void );
};
// ------------------------------------------------------------------------

char   StartPath[200]="" ;
char  *StrExit="Exit";

short  px=0 ;          //  
short  n_Wort=5 ;

t_WorterBuch  Buch ;
t_Stande1     Stande1 ;
short         i_File=0 ;
static Window Win ;

XFontStruct *Font0,*Font1,*Font2,*Font3,*Font4 ;
short        Color0=0xf0,Color1=0x0f,Color2=0x0f,Color3=0x0f,Color4=0x0f ;

void  main_loop( void );
void  antwort( long i_wort );
void  init_dic_menu( void );
void  init_buch( char *StartPath );
void  read_buch( void *Str );
void  f_exit( void *V );

void  paint( long i_wort, char *Str, short PX, char Cursor=0 );
void  paint1( long i_wort, short x, short y );
void  set_param( void );

int   load_rcfile( char* rcfile_name, char* cgi_type );
void  set_path( int argc, char *argv[] );
char* get_value( char* name );
short tcolor( char *str );
void  x_begin_schone( int argc, char *argv[] );

/***************************************************************************/
int main( int argc, char *argv[] )
{  char r ;

   setlocale( LC_ALL,"" );
   x_begin_schone( argc, argv );
   r=Stande1.read1( );
   set_path( argc, argv );

   init_buch( StartPath );
   init_dic_menu( );

   Stande1.init( );
   if( r<0 ) Stande1.write( );
       else  Stande1.read2( );

   i_File=Stande1.i_default_Dict ;
   read_buch( file_menu_r[i_File].data );

   main_loop();
   return 0 ;
}
/***************************************************************************/
void set_path( int argc, char *argv[] )
{  short i ;

   for( i=1 ; i<argc-1 ; i++ )
      if( 0==strcmp(argv[i],"-path") )
      {   strcpy( StartPath,argv[i+1] ) ;
	  if( StartPath[strlen(StartPath)-1]!='/' )
	      strcat( StartPath,"/" );
	  break ;
      }
}
/***************************************************************************/
void init_dic_menu( void )
{  short i ;

   file_menu_r=(struct MENU *)Calloc( n_Files+2,sizeof(struct MENU) );
   wort_menu_r[0].next=file_menu_r ;

   for( i=0 ; i<n_Files ; i++ )
   {
      file_menu_r[i].flag=3 ;
      file_menu_r[i].ret =0 ;
      file_menu_r[i].funk=read_buch ;
      file_menu_r[i].data=Files[i] ;
      file_menu_r[i].next=NULL ;
      file_menu_r[i].name=Files[i] ;
      if( 18<=i ) break ;
   }
   file_menu_r[i].flag=3 ;
   file_menu_r[i].ret =0 ;
   file_menu_r[i].funk=f_exit ;
   file_menu_r[i].data=NULL ;
   file_menu_r[i].next=NULL ;
   file_menu_r[i].name=StrExit ;
   i++ ;
   file_menu_r[i].flag=0 ;
   file_menu_r[i].ret =0 ;
   file_menu_r[i].funk=NULL ;
   file_menu_r[i].data=NULL ;
   file_menu_r[i].next=NULL ;
   file_menu_r[i].name=NULL ;
}
/***************************************************************************/
void main_loop( void )
{
   char  Str[40]="" ;
   long  i ;

   Buch.i_wort=0 ;
   init_menu(  );
   Buch.read_paragraf( Buch.i_wort );

   while( 1 )
   {  short t1,t2 ;
   
      Buch.read_paragraf( Buch.i_wort );
      paint( Buch.i_wort,Str,px );
      s_getch( &t1,&t2 );
      switch( t1 )
      {
      case S_key_Back: case S_key_Del:
		       Str[--px]=0 ; break ;
      case '\r':       antwort( Buch.i_wort ); Str[px=0]=0 ; break ;
      case S_key_Esc : break ;
      default:         if( 40<=px ) break ;
		       Str[px++]=t1 ; Str[px]=0 ;
		       i=Buch.find( Str );
		       if( i<0 ) Str[--px]=0 ;
			   else  Buch.i_wort=i ;
		       break ;
      case 0 :
	 switch( t2 )
	 {
	    case S_key_Up:    if( 0<Buch.i_wort ) Buch.i_wort-- ; break ;
	    case S_key_Down:  if( Buch.i_wort<Buch.n_sy_Word ) Buch.i_wort++ ; break ;
	    case S_key_PgUp:  Buch.i_wort-=n_Wort ;
			      if( Buch.i_wort<0 )
				  Buch.i_wort=0 ;
			      break ;
	    case S_key_PgDn:  Buch.i_wort+=n_Wort ;
			      if( Buch.n_sy_Word<=Buch.i_wort )
				  Buch.i_wort=Buch.n_sy_Word-1 ;
			      break ;
	    case S_key_F10:   menu();
	 }
	 break ;
      }
   }
}
/***************************************************************************/
//             
/***************************************************************************/
void antwort( long i_wort )
{
   short x=0,y=0 ;
   short t1,t2 ;
   char  Str1[80] ;

   while( 1 )
   {
      strcpy( Str1,Buch.wort(i_wort) );
      //paint( i_wort, Str1, 0 );
      paint( i_wort, Str1, 0, -1 );
      paint1( i_wort,x,y );
      s_getch( &t1,&t2 );
      switch( t1 )
      {
      case S_key_Esc : case S_key_Enter :
	 paint1( -1,x,y ); return ;
      case 0 :
	 switch( t2 )
	 {
	    case S_key_Up:    y=max(0 ,y-1); break ;
	    case S_key_Down:  y=min(50,y+1); break ;
	    case S_key_Left:  x=max(0 ,x-1); break ;
	    case S_key_Right: x=min(80,x+1); break ;
	    case S_key_F10:   paint1( -1,x,y ); return ;
	 }
      }
   }
}
/***************************************************************************/
void paint( void )
{
   paint( -1, "", 0 );
}
/***************************************************************************/
void paint( long i_wort, char *Str, short PX, char Cursor )
{  short Size_X,Size_Y ;
   short Y0=30, Y1,Y2,Y3 ;
   short c1,c2 ;

   ss_get_size( &Size_X,&Size_Y );

   null_menu( );

   c1=Color1&0x0f ; c2=(Color1>>4)&0x0f ;

   t_GC GC( Win, 0, 0 );
   GC.FillRectangle( 0,Y0,Size_X,7 );

   GC.SetForeground( 15 );
   XSetLineAttributes( Dis,GC.GC1,2,LineSolid,CapNotLast,JoinMiter );

   short x1,y1,x2,y2 ;
   x1=5    ; x2=Size_X-5 ;
   y1=Y0+5 ; y2=Size_Y-5 ;

   GC.DrawLine( x1,y1,x2,y1 );
   GC.DrawLine( x1,y2,x2,y2 );
   GC.DrawLine( x1,y1,x1,y2 );
   GC.DrawLine( x2,y1,x2,y2 );

   Y1=Size_Y/2 ;
   Y2=Y1+30 ;
   Y3=Y2+30 ;
   GC.DrawLine( 5,Y1,Size_X-5,Y1 );
   GC.DrawLine( 5,Y2,Size_X-5,Y2 );
   GC.DrawLine( 5,Y3,Size_X-5,Y3 );

   GC.SetForeground( c2 );
   GC.FillRectangle( 7,Y0+7,Size_X-14,Y1-Y0-9 );

   short Symbol_W = Font1->max_bounds.width;
   short Symbol_H = Font1->ascent + Font1->descent;
   n_Wort=(Y1-Y0-10)/Symbol_H ;

   long   i,i1,x,FirstWord ;
   char   Str1[2]=" " ;

   FirstWord=Buch.i_Paragraf*16 ;
   if( FirstWord<(i_wort-n_Wort+1) ) FirstWord=(i_wort-n_Wort+1);

   GC.SetForeground( c1 ); GC.SetBackground( c2 );
   XSetFont( Dis, GC.GC1, Font1->fid );
   for( i=0 ; i<n_Wort ; i++ )
   {  i1=FirstWord+i ;
      if( i1==i_wort && Cursor==0 )
	  GC.FillRectangle( 20,Y0+8+Symbol_H*i,Size_X-40,Symbol_H );
      if( i1==i_wort && Cursor==0 ) 
      {  GC.SetForeground( c2 ); GC.SetBackground( c1 );  }
      GC.DrawImageString( 20, Y0+5+Symbol_H*(i+1), Buch.wort( i1 ) );
      if( i1==i_wort && Cursor==0 ) 
      {  GC.SetForeground( c1 ); GC.SetBackground( c2 );  }
   }

   c1=Color2&0x0f ; c2=(Color2>>4)&0x0f ;
   GC.SetForeground( c2 );
   GC.FillRectangle( 7,Y1+2,Size_X-14,Y2-Y1-4 );
   GC.SetForeground( c1 ); GC.SetBackground( c2 );
   GC.DrawImageString( 20, Y1+Symbol_H, Str );

   c1=Color3&0x0f ; c2=(Color3>>4)&0x0f ;
   GC.SetForeground( c2 );
   GC.FillRectangle( 7,Y2+2,Size_X-14,Y3-Y2-4 );

   c1=Color4&0x0f ; c2=(Color4>>4)&0x0f ;
   GC.SetForeground( c2 );
   GC.FillRectangle( 7,Y3+2,Size_X-14,Size_Y-Y3-10 );

   XSetFont( Dis, GC.GC1, Font0->fid );
   GC.SetForeground( 15 ); GC.SetBackground( 0 );
   long L=XTextWidth( Font0, "F10 ",8 );
   GC.DrawImageString( Size_X-L-10, Size_Y-5, "F10 " );
}
/***************************************************************************/
//                                         //
/***************************************************************************/
void paint1( long i_wort, short x, short y )
{
   short i,j,j1,s,L ;
   char  *Str,Str1[100] ;
   short Size_X,Size_Y ;
   short Y0=30, Y1,Y2,Y3 ;
   short n_Str ;
   short c1,c2 ;
   t_GC GC( Win,0,0 );

   ss_get_size( &Size_X,&Size_Y );
   short Symbol_H = Font4->ascent + Font4->descent;

   Y2=Size_Y/2+30 ;
   Y3=Size_Y/2+60 ;
   n_Str = (Size_Y-Y3-10)/Symbol_H ;

   c1=Color3&0x0f ; c2=(Color3>>4)&0x0f ;
   GC.SetForeground( c2 );
   GC.FillRectangle( 7,Y2+2,Size_X-14,Y3-Y2-4 );
   GC.SetForeground( c1 ); GC.SetBackground( c2 );
   XSetFont( Dis, GC.GC1, Font3->fid );
   GC.DrawImageString( 20, Y2+Symbol_H, Buch.trans( i_wort ) );
 /*  
   char Str2[41] ;
   for( i=0 ; i<40 ; i++ )
       Str2[i]=i_wort+i ;
   Str2[41]=0 ;    
   GC.DrawImageString( 20, Y2+Symbol_H, Str2 );
*/
   c1=Color4&0x0f ; c2=(Color4>>4)&0x0f ;

   GC.SetForeground( c2 );
   GC.FillRectangle( 7,Y3+2,Size_X-14,Size_Y-Y3-10 );
   XSetFont( Dis, GC.GC1, Font4->fid );

   if( i_wort<0 ) return ;
   GC.SetForeground( c1 );
   GC.SetBackground( c2 );

   Str=Buch.answer( i_wort );
   L=strlen( Str );
   for( i=0,s=j=j1=0 ; i<L ; i++ )
   {  if( Str[i]=='\n' || i==L-1 )
      {  Str1[j++]=0;
	 if( y<=s && s-y<n_Str )
	     GC.DrawImageString( 20, Y3+Symbol_H*(s-y+1), Str1 );
	 j=j1=0 ; s++ ;
      }
      else
      {  if( (j1++)<x || 40<j ) continue ;
	 Str1[j++]=Str[i] ;
      }
   }
}
/***************************************************************************/
void set_param( void )
{  t_DictStande *DS=Stande1.Dict+i_File+1 ;
   XFontStruct *FF ;

   if( (FF = XLoadQueryFont( Dis, Stande1.Dict[0].Text[0].Font )) != NULL )
       Font0=FF ;
   Color0 = DS->Text[0].color ;

   if( (FF = XLoadQueryFont( Dis, DS->Text[1].Font )) != NULL )
       Font1=FF ;
   Color1 =  DS->Text[1].color ;

   if( (FF = XLoadQueryFont( Dis, DS->Text[2].Font )) != NULL )
       Font2=FF ;
   Color2 =  DS->Text[2].color ;

   if( (Font3 = XLoadQueryFont( Dis, DS->Text[3].Font )) == NULL )
       Font3=FF ;
   Color3 =  DS->Text[3].color ;

   if( (FF = XLoadQueryFont( Dis, DS->Text[4].Font )) != NULL )
       Font4=FF ;
   Color4 =  DS->Text[4].color ;
   //Font2=Font4=Font1 ;

   Buch.set_divider( DS->Divider ) ;
   Buch.set_sort( DS->SortOrder ) ;
}
/***************************************************************************/
void read_buch( void *Str )
{  short i,i_Dict=0 ;
   char  Name[200] ;

   strcpy( Name,StartPath );
   strcat( Name,(char *)Str );
   Buch.make( Name );

   for( i=0 ; i<n_Files ; i++ )
      if( 0==strcmp(Files[i],(char *)Str) )
      {   i_Dict=i+1 ; break ;  }
   i_File=i_Dict-1 ;
   set_param( );
   Buch.i_wort=0 ;
   Buch.read_paragraf( Buch.i_wort );
}
/****************************************************************************/
void  f_exit( void *V )
{
   exit(0);
}
/* ----------------------------------------------------------------------- */
void t_Stande1::init( void )
{  short i,i1 ;

   Dict=(t_DictStande *)Calloc( n_Files+1,sizeof(t_DictStande));
   for( i=0 ; i<=n_Files ; i++ )
   {
      strcpy( Dict[i].Divider,"=" );
      Dict[i].fTrans=0 ;
      Dict[i].SortOrder=0 ;
      for( i1=0 ; i1<5 ; i1++ )
      {  Dict[i].Text[i1].color=0xf0 ;
	 strcpy( Dict[i].Text[i1].Font,
		 "-cronyx-courier-medium-r-normal--17-120-100-100-m-90-koi8-r" );
	 if( i1==3 )
	 strcpy( Dict[i].Text[i1].Font,
		 "-unknown-sildoulosipa-regular-r-normal--17-120-100-100-p-90-adobe-fontspecific" );
      }
   }
}
/***************************************************************************/
/*                                                  */
/***************************************************************************/
char t_Stande1::read1( void )
{
   char  *h,*Val ;
   char   File[200],Var[200],Prefix[50] ;

   File[0]=0 ;
   h=getenv( "HOME" );
   if( h!=NULL ) strcpy( File,h );
   strcat( File,"/.slowo.ini" );

   if( 0!=load_rcfile( File, "" ) ) return -1;

   Val=get_value( "Path" );
   if( Val!=NULL ) strcpy( StartPath,Val ) ;
   return 0 ;
}
/* ----------------------------------------------------------------------- */
void  t_Stande1:: read2( void )
{
   short  i,i1,L ;
   char  *h,*Val ;
   FILE  *fw ;
   char   File[200],Var[200],Prefix[50] ;
   char  *DefaultDict ;

   DefaultDict=get_value( "DefaultDict" );
   for( i=0 ; i<=n_Files ; i++ )
   {
      if( i==0 ) strcpy( Prefix,"" );
      else
      {  strcpy( Prefix,Files[i-1] );
	 L=strlen( Prefix );
	 Prefix[L-4]=':' ; Prefix[L-3]=0 ;
	 if( DefaultDict!=NULL && 0==strcmp( Files[i-1],DefaultDict ) )
	     i_default_Dict=i-1 ;
      }
      if( i!=0 ) Dict[i]=Dict[0] ;

      sprintf( Var,"%s%s",Prefix,"List.Font" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Text[1].Font,Val );

      sprintf( Var,"%s%s",Prefix,"Word.Font" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Text[2].Font,Val );

      sprintf( Var,"%s%s",Prefix,"Transcript.Font" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Text[3].Font,Val );

      sprintf( Var,"%s%s",Prefix,"Translate.Font" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Text[4].Font,Val );

      sprintf( Var,"%s%s",Prefix,"List.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[1].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Word.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[2].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Transcript.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[3].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Translate.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[4].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Divider" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Divider,Val );

      sprintf( Var,"%s%s",Prefix,"SortOrder" );
      Val=get_value( Var );
      if( Val!=NULL && 0==strcmp(Val,"Euro") ) 
          Dict[i].SortOrder=1 ;

      sprintf( Var,"%s%s",Prefix,"Translate" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].fTrans=(0==strcmp( "1",Val ));
   }
}
/* ----------------------------------------------------------------------- */
void  t_Stande1:: write( void )
{
   short  i,i1,L ;
   char  *h ;
   FILE  *fw ;
   char   File[200],Prefix[50]="" ;

   File[0]=0 ;
   h=getenv( "HOME" );
   if( h!=NULL ) strcpy( File,h );
   strcat( File,"/.slowo.ini" );

   fw=Fopen( File,"w" );
   
   fprintf( fw,"Path %s",StartPath );

   for( i=0 ; i<=n_Files ; i++ )
   {
      if( i!=0 )
      {  strcpy( Prefix,Files[i-1] );
	 L=strlen( Prefix );
	 Prefix[L-4]=0 ;
	 fprintf( fw,"\n%s\n{",Prefix );
	 Prefix[L-4]=':' ; Prefix[L-3]=0 ;
      }

      fprintf( fw,"\nList.Font        %s",Dict[i].Text[1].Font );
      fprintf( fw,"\nWord.Font        %s",Dict[i].Text[2].Font );
      fprintf( fw,"\nTranscript.Font  %s",Dict[i].Text[3].Font );
      fprintf( fw,"\nTranslate.Font   %s",Dict[i].Text[4].Font );

      fprintf( fw,"\nList.Color       0x%02x",Dict[i].Text[1].color&0x0ff );
      fprintf( fw,"\nWord.Color       0x%02x",Dict[i].Text[2].color&0x0ff );
      fprintf( fw,"\nTranscript.Color 0x%02x",Dict[i].Text[3].color&0x0ff );
      fprintf( fw,"\nTranslate.Color  0x%02x",Dict[i].Text[4].color&0x0ff );

      fprintf( fw,"\nDivider          \"%s\"",Dict[i].Divider );
      fprintf( fw,"\nTranslate        %d",Dict[i].fTrans );

      if( i!=0 )
      {   fprintf( fw,"\n}" );  }
   }

   fclose( fw );
}
/* ----------------------------------------------------------------------- */
short tcolor( char *str )
{  short f1=0,f2=7 ;

   if( str[0]!='0' || str[1]!='x' ) return -1 ;
   if( '0'<=str[2] && str[2]<='9' ) f1=str[2]-'0' ;
   if( 'a'<=str[2] && str[2]<='f' ) f1=str[2]-'a'+10 ;
   if( 'A'<=str[2] && str[2]<='F' ) f1=str[2]-'A'+10 ;
   if( '0'<=str[3] && str[3]<='9' ) f2=str[3]-'0' ;
   if( 'a'<=str[3] && str[3]<='f' ) f2=str[3]-'a'+10 ;
   if( 'A'<=str[3] && str[3]<='F' ) f2=str[3]-'A'+10 ;
   return (f1<<4)+f2 ;
}

